SDKP_DEFAULTS = {
    profile = {
        trackloot = true,
        lootfilter = { 
			["ff1eff00"] = false,	-- Uncommon
			["ff0070dd"] = true,	-- Rare
			["ffa335ee"] = true,	-- Epic
			["ffff8000"] = true,	-- Legendary
        },
        ignoreloot = {
			["Sunmote"] = true,
			["Lionseye"] = true,
			["Badge of Justice"] = true,
			["Pyrestone"] = true,
			["Crimson Spinel"] = true,
			["Seaspray Emerald"] = true,
			["Void Crystal"] = true,
			["Empyrean Sapphire"] = true,
			["Shadowsong Amethyst"] = true,
			["Large Prismatic Shard"] = true,
        },
        debug = false,
        snapshots = {},
    	waitlist = {},
    	waitlistData = {},
    	banlist = {},
    	bids = {},
    	loot = {},
    	
    	checkattendance = true,
    	relationaldkp = false,
		initialgearvalue = 0,
		announceloot = true,
		taxrate = .30,
		taxthreshold = 30,
		attchecklen = 180, -- 3 min
		sanctionlen = 240,
		checkwaitlist = false,
    },
};

SDKP_OPTIONS = {
    name = "Sachmo's Dkp Mod",
    type = 'group',
    handler = sdkp,
    childGroups = "tab",
    args = {
    	
    	-- Main options tab.
    	main = {
    		name = "Main",
    		type = "group",
    		cmdInline = true,
    		order = 1,
    		args = {
    		   	checkatt = {
		   			name = "checkatt",
		   			type = "execute",
		   			desc = "Require all people in the attendance list to report in.",
		   			func = "CmdCheckAtt",
		   			guiHidden = true,
		   			order = 1,
		   		},
    	   		help = {
		   			name = "help",
		   			type = "execute",
		   			desc = "Prints usage info",
		   			func = function() LibStub("AceConfigCmd-3.0").HandleCommand(sdkp, "sdkp", "sdkp", ""); end,
		   			guiHidden = true,
		   			order = 1,
		   		},
		    	show = {
		   			name = "show",
		   			type = "execute",
		   			desc = "Show the bidding window",
		   			func = function() sdkp:ShowBids(); end,
		   			guiHidden = true;
					order = 2,
		   		},
		   		sync = {
		   			name = "sync",
		   			type = "input",
		   			desc = "syncs data with player",
		   			set = "CmdSync",
		   			guiHidden = true;
					order = 3,
		   		},		   	
		    	
		    	snapshotdata = {
		    		name = "Snapshot Data",
		    		type = "group", 
		    		inline = true,
		    		order = 5, 
		    		args = {
			    		purge = {
				    		name = "Purge",
				    		type = "execute",
				    		desc = "Purges snapshot and loot data.",
				    		func = "Purge",
				    		confirm = function() return true end, -- AceConfigConsole barfs on boolean type.
				    		confirmText = "Are you sure you want to purge all snapshot and loot data?",
				    		order = 5,
				    		width = "half",
				    	},
				    	export = {
				   			name = "Export",
				   			type = "execute",
				   			desc = "Export Snapshot Data",
				   			func = "CmdExport",
							order = 6,
							width = "half",
				   		},
		    		},
		    	},		
		    	
		    	misc = {
		    	   	name = "Misc",
		    		type = "group", 
		    		inline = true,
		    		order = 10, 
		    		args = { 	
		    		    debug = {
				    		name = "Debug",
				    		type = "toggle",
				    		desc = "Print debug info",
				    		get = "IsDebug",
				    		set = "ToggleDebug",
				    		order = 1,
				    	},
				    },
			    },
    		},
    	},
    	
    	-- Loot options tab.
    	loot = {
    		name = "Loot",
    		type = "group",
    		cmdInline = true,
    		order = 2,
    		args = {
    			trackloot = {
		    		name = "Track loot",
		    		type = "toggle",
		    		desc = "On/Off Tracking of loot.",
		    		get = "IsTrackLoot",
					set = "ToggleTrackLoot",
					width = "full",
					order = 0,												 
		    	},
		    	announceloot = {
		    		name = "Announce loot",
		    		type = "toggle",
		    		desc = "On/Off Announcing of loot in guild chat, if tracking loot.",
		    		get = "IsAnnounceLoot",
					set = "ToggleAnnounceLoot",
					width = "full",
					disabled = function(info) return not sdkp:IsTrackLoot(info) end,
					order = 1,												 
		    	},
		    	taxthreshold = {
		    		name = "Tax threshold", 
		    		type = "range",
		    		min = 0,
		    		max = 100,
		    		step = 1,
		    		bigStep = 1,
		    		desc = "If a player's dkp is greater than this amount, players will be taxed on purchases.",
		    		get = "GetTaxThreshold",
					set = "SetTaxThreshold",
					width = "full",
					disabled = function(info) return not sdkp:IsTrackLoot(info) end,
					order = 5,												 
		    	},
		    	taxrate = {
		    		name = "Tax rate", 
		    		type = "range",
		    		min = 0,
		    		max = 1,
		    		step = 0.01,
		    		bigStep = 0.01,
		    		isPercent = true,
		    		desc = "Purchases will be taxed at this rate if the threshold is met.",
		    		get = "GetTaxRate",
					set = "SetTaxRate",
					width = "full",
					disabled = function(info) return not sdkp:IsTrackLoot(info) end,
					order = 6,												 
		    	},
		    	lootfilter = {
		    		name = "Track items of these qualities:",
		    		type = "multiselect",
		    		desc = "Track this type of loot, if tracking loot.",
		    		values = {
						"Uncommon",
						"Rare",
						"Epic",
						"Legendary",
					},
		    		get = "GetLootFilter",
		    		set = "SetLootFilter",
		    		disabled = function(info) return not sdkp:IsTrackLoot(info) end,
		    		order = 9,
		    	},
		    	-- Toggle tracking of loot  	
		    	ignoreloot = {
		    		name = "Ignore loot",
		    		type = "input",
		    		desc = "alternate: |cffffff78il|r - Toggle loot from ignore list.    (ex: /sdkp il |cff0070dd|Hitem:32428:0:0:0:0:0:0:0|h[Heart of Darkness]|h|r)",
		    		set = "CmdIgnoreLoot",
		    		guiHidden = true,
		    	},
		    	il = {
		    		name = "il",
		    		type = "input",
		    		set = "CmdIgnoreLoot",
		    		hidden = true,
		    	},
    		},
    	},
    	
    	-- Dkp system options tab.
    	dkpsystem = {
    		name = "Dkp",
    		type = "group",
    		cmdInline = true,
    		order = 3,
    		args = {
    			checkattendance = {
		    		name = "Enable attendance checks",
		    		type = "toggle",
		    		desc = "Initiate a guild attendance check when taking a snapshot. (Only happens if tracking loot)",
		    		get = "IsAttCheck",
					set = "ToggleAttCheck",
					width = "full",
					disabled = function(info) return not sdkp:IsTrackLoot(info) end,
					order = 0,												 
		    	},
		    	attchecklen = {
		    		name = "Attendance check length", 
		    		type = "range",
		    		min = 10,
		    		max = 6*60,
		    		step = 1,
		    		bigStep = 5,
		    		desc = "How long an attendance check will remain active. (time in seconds)",
		    		get = "GetAttCheckLen",
					set = "SetAttCheckLen",
					width = "full",
					disabled = function(info) return not (sdkp:IsTrackLoot(info) and sdkp:IsAttCheck(info)) end,
					order = 1,												 
		    	},
		    	sanctionlen = {
		    		name = "Whisper bot sanction penalty", 
		    		type = "range",
		    		min = 10,
		    		max = 6*60,
		    		step = 1,
		    		bigStep = 5,
		    		desc = "How long a sanction will remain active. (time in seconds)",
		    		get = "GetSanctionLen",
					set = "SetSanctionLen",
					width = "full",
					disabled = function(info) return not (sdkp:IsTrackLoot(info) and sdkp:IsAttCheck(info)) end,
					order = 2,												 
		    	},
		    	checkwaitlist = {
		    		name = "Enable waitlist",
		    		type = "toggle",
		    		desc = "Allow players to add themselves to a waitlist. The waitlist will be added to each boss snapshot.",
		    		get = "IsWaitlist",
					set = "ToggleWaitlist",
					width = "full",
					disabled = function(info) return not sdkp:IsTrackLoot(info) end,
					order = 3,												 
		    	},
		    		
    			relationaldkp = {
		    		name = "Relational Dkp",
		    		type = "group", 
		    		inline = true,
		    		order = 10, 
		    		args = {
				    	userelationaldkp = {
				    		name = "Use Relational Dkp",
				    		type = "toggle",
				    		desc = "Select to enable use of relational dkp system.",
				    		get = "IsRelationalDkp",
							set = "ToggleRelationalDkp",
							order = 0,												 
				    	},
				    	initialgearvalue = {
				    		name = "Initial Gear Value",
				    		type = "input",
				    		usage = "Must be a number.",
				    		pattern = "%d+%.?%d*",
				    		desc = "This number is added to the spent dkp of a player in the relational dkp system",
				    		get = "GetInitialGearValue",
							set = "SetInitialGearValue",
							multiline = false;
							disabled = function(info) return not sdkp:IsRelationalDkp(info); end,
							order = 1,												 
				    	},
		    		},
		    	},		
    		},
    	},
    	
    	-- Manually assign loot to a player  	
    	assignloot = {
    		name = "Ignore loot",
    		type = "input",
    		desc = "alternate: |cffffff78al|r - Manually assign loot to a player (ex: /sdkp al |cff0070dd|Hitem:32428:0:0:0:0:0:0:0|h[Heart of Darkness]|h|r Sachmo)",
    		set = "CmdAssignLoot",
    		guiHidden = true,
    	},
    	al = {
    		name = "il",
    		type = "input",
    		set = "CmdAssignLoot",
    		hidden = true,
    	},
    	
    	-- Manually assign noobery to a player  	
    	noob = {
    		name = "Noobery",
    		type = "input",
    		desc = "Manually assign Minor Noobery penalty to a player (ex: /sdkp minornoob Sachmo)",
    		set = function(info, player) sdkp:CmdNoobery("minor", player) end,
    		guiHidden = true,
    	},
    	
    	-- Manually assign major noobery to a player  	
    	majornoob = {
    		name = "Major Noobery",
    		type = "input",
    		desc = "Manually assign Major Noobery penalty to a player (ex: /sdkp majornoob Sachmo)",
    		set = function(info, player) sdkp:CmdNoobery("major", player) end,
    		guiHidden = true,
    	},
    	
    	-- Manually add/remove to snapshot
    	ss = {
    		name = "ss",
    		desc = "Force a snapshot, or add/remove people from the last one. [ /sdkp ss ] for more info.",
    		type = "group",
    		order = 7,
    		guiHidden = true,
    		args = {
	    		add = {
	    			name = "ss_add",
	    			desc = "Add player to the last snapshot.    (ex: /sdkp ss add Sachmo)",
	    			type = "input",
	    			set = function (info, player)
	    				local snapshots = sdkp.db.profile.snapshots;
	    				if snapshots and snapshots[#snapshots] then 
	    					sdkp:CmdHandleManualSnapshot(player, "add", snapshots[#snapshots]);
	    				else
	    					sdkp:Print("no snapshots found to add to!");
	    				end
	    			end,
	    			guiHidden = true,
	    			order = 1,
	    		},
	    		remove = {
	    			name = "ss_remove",
	    			desc = "Remove player from the last snapshot.    (ex: /sdkp ss remove Sachmo)",
	    			type = "input",
	    			set = function (info, player)
	    				local snapshots = sdkp.db.profile.snapshots;
	    				if snapshots and snapshots[#snapshots] then 
	    					sdkp:CmdHandleManualSnapshot(player, "remove", snapshots[#snapshots]);
	    				else
	    					sdkp:Print("no snapshots found to remove from!");
	    				end
	    			end,
	    			guiHidden = true,
	    			order = 2,
	    		},
	    		force = {
	    			name = "ss_force",
	    			desc = "force a snapshot to be taken.  (ex: /sdkp ss force)",
	    			type = "execute",
	    			func = "CmdSnapshot",
	    			guiHidden = true,	  
	    			order = 3,  		
	    		},
		    }, -- args
	    }, -- ss
	    
	    -- Manually control the waitlist
    	wl = {
    		name = "waitlist",
    		desc = "View the waitlist, add/remove people or strip people of attendance/dkp for the night. [ /sdkp wl ] for more info.",
    		type = "group",
    		order = 8,
    		guiHidden = true,
    		args = {
	    		add = {
	    			name = "wl_add",
	    			desc = "Add player to the waitlist.    (ex: /sdkp wl add Josua)",
	    			type = "input",
	    			set = function (info, player)
	    				sdkp:CmdHandleManualWaitlist(player, "add");
	    			end,
	    			guiHidden = true,
	    			order = 1,
	    		},
	    		remove = {
	    			name = "wl_remove",
	    			desc = "Remove player from the waitlist.    (ex: /sdkp wl remove Josua)",
	    			type = "input",
	    			set = function (info, player)
	    				sdkp:CmdHandleManualWaitlist(player, "remove");
	    			end,
	    			guiHidden = true,
	    			order = 2,
	    		},
	    		strip = {
	    			name = "wl_strip",
	    			desc = "Strip the player from all snapshots.  (ex: /sdkp wl strip Josua)",
	    			type = "input",
	    			set = function (info, player)
	    				sdkp:CmdHandleManualWaitlist(player, "strip");
	    			end,
	    			guiHidden = true,	  
	    			order = 3,  		
	    		},
	    		ban = {
	    			name = "wl_ban",
	    			desc = "Add the player to the banlist.  (ex: /sdkp wl ban Josua)",
	    			type = "input",
	    			set = function (info, player)
	    				sdkp:CmdHandleManualWaitlist(player, "ban");
	    			end,
	    			guiHidden = true,	  
	    			order = 4,  		
	    		},
	    		unban = {
	    			name = "wl_unban",
	    			desc = "Remove the player from the banlist.  (ex: /sdkp wl unban Josua)",
	    			type = "input",
	    			set = function (info, player)
	    				sdkp:CmdHandleManualWaitlist(player, "unban");
	    			end,
	    			guiHidden = true,	  
	    			order = 5,  		
	    		},
	    		who = {
	    			name = "wl_who",
	    			desc = "Display everyone currently on the waitlist.  (ex: /sdkp wl who)",
	    			type = "input",
	    			set = function (info)
	    				local waitlist = sdkp.db.profile.waitlist;
	    				sdkp:Print("Current waitlist: " .. sdkp:CmdWaitlistString(waitlist));
	    			end,
	    			guiHidden = true,	  
	    			order = 6,  		
	    		},
	    		whoban = {
	    			name = "wl_whoban",
	    			desc = "Display everyone currently on the banlist.  (ex: /sdkp wl whoban)",
	    			type = "input",
	    			set = function (info)
	    				local banlist = sdkp.db.profile.banlist;
	    				sdkp:Print("Current BANNED list: " .. sdkp:CmdWaitlistString(banlist));
	    			end,
	    			guiHidden = true,	  
	    			order = 7,  		
	    		},
	    		startraid = {
	    			name = "startraid",
	    			desc = "start the raid (clears waitlist and starts adding it to snapshots).  (ex: /sdkp wl startraid)",
	    			type = "execute",
	    			func = "CmdStartRaid",
	    			guiHidden = true,	  
	    			order = 8,  		
	    		},
	    		stopraid = {
	    			name = "stopraid",
	    			desc = "stop the raid (announces end of raid night, and starts timer to strip remaining waitlist from snapshots).  (ex: /sdkp wl stopraid)",
	    			type = "execute",
	    			func = "CmdStopRaid",
	    			guiHidden = true,	  
	    			order = 9,  		
	    		},
		    }, -- args
	    }, -- wl
	    
	    st = {
	    	name = "st",
	    	desc = "st",
	    	type = "execute",
		   	desc = "Show the bidding window",
		   	func = "ST",
		   	guiHidden = true;
			order = 10,
	    }
    }, -- args
};

SDKP_COLORS = {
	"ff1eff00", -- [1]
	"ff0070dd", -- [2]
	"ffa335ee", -- [3]
	"ffff8000", -- [4]
};
SDKP_ICOLORS = {
	["ff1eff00"] = 1,
	["ff0070dd"] = 2,
	["ffa335ee"] = 3,
	["ffff8000"] = 4,
};

SDKP_FILTERS_LIST = {
	"Show All", -- [1]
	"Only Raid", -- [2]
};
SDKP_FILTERS = {
	[SDKP_FILTERS_LIST[1]] = function(self, row)
		return true;
	end, -- [1]
	[SDKP_FILTERS_LIST[2]] = function(self, row)
		local nRaidMembers = GetNumRaidMembers();
		for i = 1, nRaidMembers do
			local raidMember = GetRaidRosterInfo(i);
			if row.cols[1].value == raidMember then 
				return true;
			end
		end
		return false;
	end, -- [2]
};


SDKP_RAID_ZONE = {
	["Black Temple"] = true,
	["Sunwell Plateau"] = true,
	["Naxxramas"] = true,
	["The Obsidian Sanctum"] = true,
	["The Eye of Eternity"] = true,
	["Ulduar"] = true,
};

SDKP_EMBLEMS = {
	["40752"] = "Emblem of Heroism",
	["40753"] = "Emblem of Valor",
	["45624"] = "Emblem of Conquest",
};

-- this is mostly to prevent the scrolling table from adding ppl in bg raids.
SDKP_NOUPDATE_ZONE = { 
	["Alterac Valley"] = true,
	["Warsong Gulch"] = true,
	["Arathi Basin"] = true,
	["Eye of the Storm"] = true,
};

-- single quotes fuck up the import( wont track loot as single raid for boss )... SIGH
SDKP_UNIT_TO_ENCOUNTER = {
	-- Testing SM
	["Scarlet Commander Mograine"] = "Scarlet Monastery Cathedral",
	["High Inquisitor Whitemane"] = "Scarlet Monastery Cathedral",
	-- BT
	["High Warlord Naj'entus"] = "High Warlord Najentus", -- no single quote pls..
	["Gathios the Shatterer"] = "The Illidari Council",
	["High Nethermancer Zerevor"] = "The Illidari Council",
	["Lady Malande"] = "The Illidari Council",
	["Veras Darkshadow"] = "The Illidari Council",
	["Essence of Anger"] = "Reliquary of Souls",
	-- Sunwell
	["Sathrovarr the Corruptor"] = "Kalecgos",
	["Lady Sacrolash"] = "Eredar Twins",
	["Grand Warlock Alythess"] = "Eredar Twins",
	["Entropius"] = "Muru", -- no single quote pls..
	["Kil'jaeden"] = "Kiljaeden", -- no single quote pls..
	-- Naxxramus
	["Anub'Rekhan"] = "AnubRekhan",
	["Kel'Thuzad"] = "KelThuzad",
	-- Ulduar
	["Stormcaller Brundir"] = "The Iron Council",
	["Runemaster Molgeim"] = "The Iron Council",
	["Steelbreaker"] = "The Iron Council",
};

SDKP_ZONE_TO_ENCOUNTER = {
	-- Naxxramas
	["The Horsemen's Assembly"] = "The Four Horsemen",
	-- Ulduar
	["The Shattered Walkway"] = "Kologarn",
	["The Halls of Winter"] = "Hodir",
	["The Clash of Thunder"] = "Thorim",
	["The Conservatory of Life"] = "Freya",
	["The Spark of Imagination"] = "Mimiron",
};

SDKP_UNIT_BOSS_IGNORE = {
	["Shadron"] = true,
	["Tenebron"] = true,
	["Vesperon"] = true,
	["Elder Brightleaf"] = true,
	["Elder Ironbranch"] = true,
	["Elder Stonebark"] = true,
};